#ifndef WIMESH_PARSERS
#define WIMESH_PARSERS

#include <libxml++/libxml++.h>
#include "WMtypes.h"



class TopologyParser : public xmlpp::SaxParser
{
friend class Topology;

protected:
  // protected constructor: can only be invoked from within a Topology method
  TopologyParser (Topology* _T);
  virtual ~TopologyParser();

  unsigned int defaultNradios;
  float defaultTxGainDb;
  float defaultRxGainDb;
  unsigned int defaultMinAngle;
  unsigned int defaultMaxAngle;

  // Node attributes may override default (Topology) attributes for that node's radios
  float nodeTxGainDb;
  float nodeRxGainDb;
  unsigned int nodeMinAngle;
  unsigned int nodeMaxAngle;

  Topology* T;

  //overrides:
  virtual void on_start_document();
  virtual void on_end_document();
  virtual void on_start_element(const Glib::ustring& name,
                                const AttributeList& properties);
  virtual void on_end_element(const Glib::ustring& name);
  virtual void on_characters(const Glib::ustring& characters);
  virtual void on_comment(const Glib::ustring& text);
  virtual void on_warning(const Glib::ustring& text);
  virtual void on_error(const Glib::ustring& text);
  virtual void on_fatal_error(const Glib::ustring& text);
  
};



#endif //WIMESH_PARSERS
